#include <ESP8266.h>

#define SSID        "hikanet"
#define PASSWORD    "knt55153"
#define SERVER_PORT   (9999)

SoftwareSerial mySerial( 3, 2 ); 
ESP8266 wifi( mySerial );

void setup(void)
{
    Serial.begin(9600);
    
    mySerial.begin(115200);
    mySerial.println("AT+UART_CUR=9600,8,1,0,0");
    delay(10);
    mySerial.begin(9600); 
    delay(10);
        
    if ( wifi.setOprToStation() ) {
        Serial.println( "OK:Setup" );
    } else {
        Serial.println( "Error:Setup" );
    }

    if ( wifi.joinAP( SSID, PASSWORD ) ) {
        Serial.println( wifi.getLocalIP().c_str() );
    } else {
        Serial.println( "Failed : AP Connect" );
    }

    delay(10);
    
    if ( wifi.enableMUX() ) {
        Serial.println("OK: Single");
    } else {
        Serial.println("ERROR: Single");
    }

     if (wifi.startTCPServer( SERVER_PORT ) ) {
        Serial.println("OK: Server");
    } else {
        Serial.println("ERROR: Server");
    }
    
    if (wifi.setTCPServerTimeout(10)) { 
        Serial.println("OK: Set timeout");
    } else {
        Serial.println("ERROR: Set timeout");
    }   

    Serial.println("Server stand-by.");
    delay(100);
}

void loop(void)
{
    char buffer[64] = {0};
    char msg[128] = {0};
    uint8_t mux_id;
    int len, i;
    len = wifi.recv(&mux_id, buffer, sizeof(buffer), 100);
    if (len > 0) {
        Serial.println("Connected.");

        strcat( msg, "Hola! from Arduino.");

        if( wifi.send( mux_id, msg, sizeof(msg) ) ) {
            Serial.println("OK: Send data");
        } else {
            Serial.println("Fail: Send data");
        }       
        
        if (wifi.releaseTCP(mux_id)) {
            Serial.println("OK: Release Connect ");
        }
    }
 }


